/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.PropRole
 *  fire.pb.circletask.PVPMatchTimeConfig
 *  fire.pb.main.ConfigManager
 *  mkdb.Mkdb
 *  mkdb.Procedure
 *  mkio.Protocol
 *  xbean.PvP1QueueRole
 *  xtable.Properties
 */
package fire.pb.battle.pvp1;

import fire.pb.PropRole;
import fire.pb.battle.pvp1.PPvP1NewBattle;
import fire.pb.battle.pvp1.PvP1Control;
import fire.pb.battle.pvp1.PvP1RaceProxy;
import fire.pb.battle.pvp1.PvP1RoleProxy;
import fire.pb.battle.pvp1.PvP1RoleSingleMatch;
import fire.pb.battle.pvp1.SPvP1MatchResult;
import fire.pb.battle.pvp1.SPvP1ReadyFight;
import fire.pb.circletask.PVPMatchTimeConfig;
import fire.pb.main.ConfigManager;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.concurrent.TimeUnit;
import mkdb.Mkdb;
import mkdb.Procedure;
import mkio.Protocol;
import xbean.PvP1QueueRole;
import xtable.Properties;

public class PPvP1PairBattleFromQueue
extends Procedure {
    private final int grade;
    public Map<Integer, PVPMatchTimeConfig> matchcfgs = ConfigManager.getInstance().getConf(PVPMatchTimeConfig.class);

    public PPvP1PairBattleFromQueue(int grade) {
        this.grade = grade;
    }

    protected boolean process() throws Exception {
        PvP1RaceProxy race = PvP1RaceProxy.getPvP1RaceProxy(this.grade);
        if (race.getXRace() == null) {
            return false;
        }
        if (!race.isOpening()) {
            return false;
        }
        if (race.getXRace().getWaitingqueue().size() < 2) {
            return false;
        }
        long now = System.currentTimeMillis();
        ArrayList<PvP1RoleProxy> pvpRoles = new ArrayList<PvP1RoleProxy>();
        Iterator it = race.getXRace().getWaitingqueue().iterator();
        while (it.hasNext()) {
            PvP1QueueRole queueRole = (PvP1QueueRole)it.next();
            PvP1RoleProxy pvpRole = PPvP1PairBattleFromQueue.validRole(race, queueRole.getRoleid(), now);
            if (pvpRole == null) {
                it.remove();
                Procedure.psendWhileCommit((long)queueRole.getRoleid(), (Protocol)new SPvP1ReadyFight(0));
                continue;
            }
            pvpRoles.add(pvpRole);
        }
        int queueSize = pvpRoles.size();
        int pairNum = this.selectPair(race, pvpRoles, 0, 0, now);
        if (PvP1Control.getLogger().isInfoEnabled()) {
            PvP1Control.getLogger().info((Object)("PVP1::[PPvP1PairBattleFromQueue] pair end. grade:" + this.grade + " queueSize:" + queueSize + " pairNum:" + pairNum + " roleNum:" + race.getXRace().getAllrolesid().size() + " rankNum:" + race.getXRace().getAllroles().size()));
        }
        return true;
    }

    private static PvP1RoleProxy validRole(PvP1RaceProxy race, long roleId, long now) {
        PvP1RoleProxy pvpRole = PvP1RoleProxy.getPvP1RoleProxy(roleId, true);
        if (!race.roleIsCanReady(roleId)) {
            return null;
        }
        return pvpRole;
    }

    private int selectPair(PvP1RaceProxy race, List<PvP1RoleProxy> pvpRoles, int startIndex, int pairnum, long now) {
        int size = race.getXRace().getWaitingqueue().size();
        if (startIndex >= size - 1) {
            return pairnum;
        }
        PvP1QueueRole hostRole = (PvP1QueueRole)race.getXRace().getWaitingqueue().get(startIndex);
        PvP1RoleProxy pvpHostRole = pvpRoles.get(startIndex);
        if (!this.roleCanFight(pvpHostRole, now)) {
            return this.selectPair(race, pvpRoles, startIndex + 1, pairnum, now);
        }
        long waitingTime = Math.max(0L, now - hostRole.getEnterqueuetime());
        for (int i = startIndex + 1; i < size; ++i) {
            PvP1RoleProxy pvpGuestRole = pvpRoles.get(i);
            if (!this.roleCanFight(pvpGuestRole, now) || !this.pair(pvpHostRole, pvpGuestRole, waitingTime)) continue;
            race.getXRace().getWaitingqueue().remove(startIndex);
            pvpRoles.remove(startIndex);
            race.getXRace().getWaitingqueue().remove(i - 1);
            pvpRoles.remove(i - 1);
            this.sendMatchResult(pvpHostRole.getRoleId(), pvpGuestRole.getRoleId());
            this.sendMatchResult(pvpGuestRole.getRoleId(), pvpHostRole.getRoleId());
            PPvP1PairBattleFromQueue.NewBattle(this.grade, pvpHostRole.getRoleId(), pvpGuestRole.getRoleId(), now);
            return this.selectPair(race, pvpRoles, startIndex, pairnum + 1, now);
        }
        return this.selectPair(race, pvpRoles, startIndex + 1, pairnum, now);
    }

    private boolean pair(PvP1RoleProxy pvpHostRole, PvP1RoleProxy pvpGuestRole, long waitingTime) {
        if (pvpHostRole.getRoleId() == pvpGuestRole.getRoleId()) {
            return false;
        }
        int hostlevel = pvpHostRole.getScoreLevel();
        int guestlevel = pvpGuestRole.getScoreLevel();
        int seconds = (int)(waitingTime / 1000L) + 1;
        int levelmod = 999;
        PVPMatchTimeConfig cfg = this.matchcfgs.get(seconds);
        if (cfg != null) {
            levelmod = cfg.lev;
        }
        int hostrolelv = Properties.selectLevel((Long)pvpHostRole.getRoleId());
        int guestrolelv = Properties.selectLevel((Long)pvpGuestRole.getRoleId());
        return Math.abs(hostlevel - guestlevel) + Math.abs(hostrolelv - guestrolelv) / 5 <= levelmod;
    }

    public boolean roleCanFight(PvP1RoleProxy pvpRole, long now) {
        return now - pvpRole.getLastBattleTime() >= 5000L;
    }

    public void sendMatchResult(long roleId, long targetId) {
        PropRole targetAttr = new PropRole(targetId, true);
        PvP1RoleSingleMatch targetInfo = new PvP1RoleSingleMatch();
        targetInfo.roleid = targetId;
        targetInfo.level = (short)targetAttr.getLevel();
        targetInfo.shape = targetAttr.getShape();
        targetInfo.school = targetAttr.getSchool();
        Procedure.psendWhileCommit((long)roleId, (Protocol)new SPvP1MatchResult(targetInfo));
    }

    private static void NewBattle(final int grade, final long hostRoleId, final long guestRoleId, final long now) {
        Procedure.pexecuteWhileCommit((Procedure)new Procedure(){

            public boolean process() {
                Mkdb.executor().schedule(new Runnable(){

                    @Override
                    public void run() {
                        new Procedure(){

                            public boolean process() {
                                boolean valid = true;
                                PvP1RaceProxy race = PvP1RaceProxy.getPvP1RaceProxy(grade);
                                if (race.getXRace() == null) {
                                    valid = false;
                                }
                                if (valid && PPvP1PairBattleFromQueue.validRole(race, hostRoleId, now) == null) {
                                    valid = false;
                                }
                                if (valid && PPvP1PairBattleFromQueue.validRole(race, guestRoleId, now) == null) {
                                    valid = false;
                                }
                                if (valid) {
                                    Procedure.pexecuteWhileCommit((Procedure)new PPvP1NewBattle(hostRoleId, guestRoleId, grade));
                                } else {
                                    Procedure.psendWhileCommit((long)hostRoleId, (Protocol)new SPvP1ReadyFight(0));
                                    Procedure.psendWhileCommit((long)guestRoleId, (Protocol)new SPvP1ReadyFight(0));
                                }
                                return true;
                            }
                        }.submit();
                    }
                }, 3L, TimeUnit.SECONDS);
                return true;
            }
        });
    }
}

